Package icyllis.modernui.graphics.drawable

# Class Drawable

java.lang.Object
icyllis.modernui.graphics.drawable.Drawable

Direct Known Subclasses:
  `AnimatedImageDrawable`, `ColorDrawable`, `ColorStateListDrawable`, `DrawableContainer`, `DrawableWrapper`, `ImageDrawable`, `LayerDrawable`, `MaterialDrawable`, `ShapeDrawable`

public abstract class Drawable extends Object
A Drawable is a general abstraction for "something that can be drawn." Most often you will deal with Drawable as the type of resource retrieved for drawing things to the screen; the Drawable class provides a generic API for dealing with an underlying visual resource that may take a variety of forms. Unlike a `View`, a Drawable does not have any facility to receive events or otherwise interact with the user.

In addition to simple drawing, Drawable provides a number of generic mechanisms for its client to interact with what is being drawn:

- The `setBounds(int, int, int, int)` method must be called to tell the Drawable where it is drawn and how large it should be. All Drawables should respect the requested size, often simply by scaling their imagery. A client can find the preferred size for some Drawables with the `getIntrinsicHeight()` and `getIntrinsicWidth()` methods.
- The `getPadding(icyllis.modernui.graphics.Rect)` method can return from some Drawables information about how to frame content that is placed inside of them. For example, a Drawable that is intended to be the frame for a button widget would need to return padding that correctly places the label inside of itself.
- The `setState(int[])` method allows the client to tell the Drawable in which state it is to be drawn, such as "focused", "selected", etc. Some drawables may modify their imagery based on the selected state.
- The `setLevel(int)` method allows the client to supply a single continuous controller that can modify the Drawable is displayed, such as a battery level or progress level. Some drawables may modify their imagery based on the current level.
- A Drawable can perform animations by calling back to its client through the `Drawable.Callback` interface. All clients should support this interface (via `setCallback(icyllis.modernui.graphics.drawable.Drawable.Callback)`) so that animations will work. A simple way to do this is through the system facilities such as `View.setBackground(Drawable)` and `ImageView`.

Though usually not visible to the application, Drawables may take a variety of forms:

- Image: a bitmap, like a PNG, JPEG, TGA or BMP image.
- Vector: a drawable defined as a set of points, lines, and curves along with its associated color information. This type of drawable can be scaled without loss of display quality.
- Shape: contains simple drawing commands instead of a raw bitmap, allowing it to resize better in some cases.
- Layers: a compound drawable, which draws multiple underlying drawables on top of each other.
- States: a compound drawable that selects one of a set of drawables based on its state.
- Levels: a compound drawable that selects one of a set of drawables based on its level.
- Scale: a compound drawable with a single child drawable, whose overall size is modified based on the current level.

At a minimum, custom drawable classes must implement the abstract methods on Drawable and should override the `draw(Canvas)` method to draw content. Significantly, consider overriding the `setAlpha(int)` to handle alpha correctly.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `Drawable.Callback`
  Implement this interface if you want to create an animated drawable that extends `Drawable`.
  `static class`
  `Drawable.ConstantState`
  This abstract class is used by `Drawable`s to store shared constant state and data between Drawables.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `MAX_LEVEL`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Drawable()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `applyTheme(Theme t)`
  Applies the specified theme to this Drawable and its children.
  `boolean`
  `canApplyTheme()`
  `void`
  `clearMutated()`
  Clears the mutated state, allowing this drawable to be cached and mutated again.
  `final Rect`
  `copyBounds()`
  Return a copy of the drawable's bounds in a new Rect.
  `final void`
  `copyBounds(Rect bounds)`
  Return a copy of the drawable's bounds in the specified Rect (allocated by the caller).
  `abstract void`
  `draw(Canvas canvas)`
  Draw in its bounds (set via setBounds) respecting optional effects such as alpha (set via setAlpha).
  `int`
  `getAlpha()`
  Gets the current alpha value for the drawable.
  `final @UnmodifiableView Rect`
  `getBounds()`
  Return the drawable's bounds Rect.
  `Drawable.Callback`
  `getCallback()`
  Return the current `Drawable.Callback` implementation attached to this Drawable.
  `int`
  `getChangingConfigurations()`
  Return a mask of the configuration parameters for which this drawable may change, requiring that it be re-created.
  `ColorFilter`
  `getColorFilter()`
  Returns the current color filter, or `null` if none set.
  `Drawable.ConstantState`
  `getConstantState()`
  Return a `Drawable.ConstantState` instance that holds the shared state of this Drawable.
  `Drawable`
  `getCurrent()`
  `void`
  `getHotspotBounds(Rect outRect)`
  Populates `outRect` with the hotspot bounds.
  `int`
  `getIntrinsicHeight()`
  Returns the drawable's intrinsic height.
  `int`
  `getIntrinsicWidth()`
  Returns the drawable's intrinsic width.
  `int`
  `getLayoutDirection()`
  Returns the resolved layout direction for this Drawable.
  `final int`
  `getLevel()`
  Retrieve the current level.
  `int`
  `getMinimumHeight()`
  Returns the minimum height suggested by this Drawable.
  `int`
  `getMinimumWidth()`
  Returns the minimum width suggested by this Drawable.
  `boolean`
  `getPadding(Rect padding)`
  Return in padding the insets suggested by this Drawable for placing content inside the drawable's bounds.
  `int[]`
  `getState()`
  Describes the current state, as a union of primitive states, such as `R.attr.state_focused`, `R.attr.state_selected`, etc.
  `boolean`
  `hasFocusStateSpecified()`
  Indicates whether this drawable has at least one state spec explicitly specifying state_focused.
  `void`
  `invalidateSelf()`
  Use the current `Drawable.Callback` implementation to have this Drawable redrawn.
  `boolean`
  `isAutoMirrored()`
  Tells if this Drawable will be automatically mirrored when its layout direction is RTL right-to-left.
  `boolean`
  `isStateful()`
  Indicates whether this drawable will change its appearance based on state.
  `final boolean`
  `isVisible()`
  `void`
  `jumpToCurrentState()`
  If this Drawable does transition animations between states, ask that it immediately jump to the current state and skip any active animations.
  `Drawable`
  `mutate()`
  Make this drawable mutable.
  `protected void`
  `onBoundsChange(Rect bounds)`
  Override this in your subclass to change appearance if you vary based on the bounds.
  `protected boolean`
  `onLayoutDirectionChanged(int layoutDirection)`
  Called when the drawable's resolved layout direction changes.
  `protected boolean`
  `onLevelChange(int level)`
  Override this in your subclass to change appearance if you vary based on level.
  `protected boolean`
  `onStateChange(int[] state)`
  Override this in your subclass to change appearance if you recognize the specified state.
  `static float`
  `scaleFromDensity(float pixels, int sourceDensity, int targetDensity)`
  Scales a floating-point pixel value from the source density to the target density.
  `static int`
  `scaleFromDensity(int pixels, int sourceDensity, int targetDensity, boolean isSize)`
  Scales a pixel value from the source density to the target density, optionally handling the resulting pixel value as a size rather than an offset.
  `void`
  `scheduleSelf(Runnable what, long when)`
  Use the current `Drawable.Callback` implementation to have this Drawable scheduled.
  `void`
  `setAlpha(int alpha)`
  Specify an alpha value for the drawable.
  `void`
  `setAutoMirrored(boolean mirrored)`
  Set whether this Drawable is automatically mirrored when its layout direction is RTL (right-to left).
  `void`
  `setBounds(int left, int top, int right, int bottom)`
  Specify a bounding rectangle for the Drawable.
  `void`
  `setBounds(Rect bounds)`
  Specify a bounding rectangle for the Drawable.
  `final void`
  `setCallback(Drawable.Callback cb)`
  Bind a `Drawable.Callback` object to this Drawable.
  `void`
  `setChangingConfigurations(int configs)`
  Set a mask of the configuration parameters for which this drawable may change, requiring that it be re-created.
  `void`
  `setColorFilter(ColorFilter colorFilter)`
  Specify an optional color filter for the drawable.
  `void`
  `setHotspot(float x, float y)`
  Specifies the hotspot's location within the drawable.
  `void`
  `setHotspotBounds(int left, int top, int right, int bottom)`
  Sets the bounds to which the hotspot is constrained, if they should be different from the drawable bounds.
  `final boolean`
  `setLayoutDirection(int layoutDirection)`
  Set the layout direction for this drawable.
  `final boolean`
  `setLevel(int level)`
  Specify the level for the drawable.
  `boolean`
  `setState(int[] stateSet)`
  Specify a set of states for the drawable.
  `void`
  `setTint(int tintColor)`
  Specifies tint color for this drawable.
  `void`
  `setTintBlendMode(BlendMode blendMode)`
  Specifies a tint blending mode for this drawable.
  `void`
  `setTintList(ColorStateList tint)`
  Specifies tint color for this drawable as a color state list.
  `boolean`
  `setVisible(boolean visible, boolean restart)`
  Set whether this Drawable is visible.
  `void`
  `unscheduleSelf(Runnable what)`
  Use the current `Drawable.Callback` implementation to have this Drawable unscheduled.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### MAX_LEVEL

    public static final int MAX_LEVEL
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Drawable

    public Drawable()

- ## Method Details

  - ### draw

    public abstract void draw(@NonNull Canvas canvas)
    Draw in its bounds (set via setBounds) respecting optional effects such as alpha (set via setAlpha).
    Parameters:
      `canvas` - The canvas to draw into

  - ### setBounds

    public void setBounds(int left, int top, int right, int bottom)
    Specify a bounding rectangle for the Drawable. This is where the drawable will draw when its draw() method is called.

  - ### setBounds

    public void setBounds(@NonNull Rect bounds)
    Specify a bounding rectangle for the Drawable. This is where the drawable will draw when its draw() method is called.

  - ### copyBounds

    public final void copyBounds(@NonNull Rect bounds)
    Return a copy of the drawable's bounds in the specified Rect (allocated by the caller). The bounds specify where this will draw when its draw() method is called.
    Parameters:
      `bounds` - Rect to receive the drawable's bounds (allocated by the caller).

  - ### copyBounds

    @NonNull public final Rect copyBounds()
    Return a copy of the drawable's bounds in a new Rect. This returns the same values as getBounds(), but the returned object is guaranteed to not be changed later by the drawable (i.e. it retains no reference to this rect). If the caller already has a Rect allocated, call copyBounds(rect).
    Returns:
      A copy of the drawable's bounds

  - ### getBounds

    @NonNull public final @UnmodifiableView Rect getBounds()
    Return the drawable's bounds Rect. Note: for efficiency, the returned object may be the same object stored in the drawable (though this is not guaranteed), so if a persistent copy of the bounds is needed, call copyBounds(rect) instead. You should also not change the object returned by this method as it may be the same object stored in the drawable.
    Returns:
      The bounds of the drawable (which may change later, so caller beware). DO NOT ALTER the returned object as it may change the stored bounds of this drawable.
    See Also:
      - `copyBounds()`
      - `copyBounds(Rect)`

  - ### setChangingConfigurations

    public void setChangingConfigurations(int configs)
    Set a mask of the configuration parameters for which this drawable may change, requiring that it be re-created.
    Parameters:
      `configs` - A mask of the changing configuration parameters

  - ### getChangingConfigurations

    public int getChangingConfigurations()
    Return a mask of the configuration parameters for which this drawable may change, requiring that it be re-created. The default implementation returns whatever was provided through `setChangingConfigurations(int)` or 0 by default. Subclasses may extend this to or in the changing configurations of any other drawables they hold.
    Returns:
      Returns a mask of the changing configuration parameters

  - ### setCallback

    public final void setCallback(@Nullable Drawable.Callback cb)
    Bind a `Drawable.Callback` object to this Drawable. Required for clients that want to support animated drawables.
    Parameters:
      `cb` - The client's Callback implementation.
    See Also:
      - `getCallback()`

  - ### getCallback

    @Nullable public Drawable.Callback getCallback()
    Return the current `Drawable.Callback` implementation attached to this Drawable.
    Returns:
      A `Drawable.Callback` instance or null if no callback was set.
    See Also:
      - `setCallback(Callback)`

  - ### invalidateSelf

    public void invalidateSelf()
    Use the current `Drawable.Callback` implementation to have this Drawable redrawn. Does nothing if there is no Callback attached to the Drawable.
    See Also:
      - `Drawable.Callback.invalidateDrawable(icyllis.modernui.graphics.drawable.Drawable)`
      - `getCallback()`
      - `setCallback(Callback)`

  - ### scheduleSelf

    public void scheduleSelf(@NonNull Runnable what, long when)
    Use the current `Drawable.Callback` implementation to have this Drawable scheduled. Does nothing if there is no Callback attached to the Drawable.
    Parameters:
      `what` - The action being scheduled.
      `when` - The time (in milliseconds) to run.
    See Also:
      - `Drawable.Callback.scheduleDrawable(icyllis.modernui.graphics.drawable.Drawable, java.lang.Runnable, long)`

  - ### unscheduleSelf

    public void unscheduleSelf(@NonNull Runnable what)
    Use the current `Drawable.Callback` implementation to have this Drawable unscheduled. Does nothing if there is no Callback attached to the Drawable.
    Parameters:
      `what` - The runnable that you no longer want called.
    See Also:
      - `Drawable.Callback.unscheduleDrawable(icyllis.modernui.graphics.drawable.Drawable, java.lang.Runnable)`

  - ### getLayoutDirection

    public int getLayoutDirection()
    Returns the resolved layout direction for this Drawable.
    Returns:
      One of `View.LAYOUT_DIRECTION_LTR`, `View.LAYOUT_DIRECTION_RTL`
    See Also:
      - `setLayoutDirection(int)`

  - ### setLayoutDirection

    public final boolean setLayoutDirection(int layoutDirection)
    Set the layout direction for this drawable. Should be a resolved layout direction, as the Drawable has no capacity to do the resolution on its own.
    Parameters:
      `layoutDirection` - the resolved layout direction for the drawable, either `View.LAYOUT_DIRECTION_LTR` or `View.LAYOUT_DIRECTION_RTL`
    Returns:
      `true` if the layout direction change has caused the appearance of the drawable to change such that it needs to be re-drawn, `false` otherwise
    See Also:
      - `getLayoutDirection()`

  - ### onLayoutDirectionChanged

    protected boolean onLayoutDirectionChanged(int layoutDirection)
    Called when the drawable's resolved layout direction changes.
    Parameters:
      `layoutDirection` - the new resolved layout direction
    Returns:
      `true` if the layout direction change has caused the appearance of the drawable to change such that it needs to be re-drawn, `false` otherwise
    See Also:
      - `setLayoutDirection(int)`

  - ### setAlpha

    public void setAlpha(@IntRange(from=0L,to=255L) int alpha)
    Specify an alpha value for the drawable. 0 means fully transparent, and 255 means fully opaque.

  - ### getAlpha

    @IntRange(from=0L, to=255L) public int getAlpha()
    Gets the current alpha value for the drawable. 0 means fully transparent, 255 means fully opaque. This method is implemented by Drawable subclasses and the value returned is specific to how that class treats alpha. The default return value is 255 if the class does not override this method to return a value specific to its use of alpha.

  - ### setTint

    public void setTint(@ColorInt int tintColor)
    Specifies tint color for this drawable.

    A Drawable's drawing content will be blended together with its tint before it is drawn to the screen.

    To clear the tint, pass `null` to `setTintList(ColorStateList)`.

    Note: Setting a color filter via `setColorFilter(ColorFilter)` overrides tint.

    Parameters:
      `tintColor` - Color to use for tinting this drawable
    See Also:
      - `setTintList(ColorStateList)`
      - `setTintBlendMode(BlendMode)`

  - ### setTintList

    public void setTintList(@Nullable ColorStateList tint)
    Specifies tint color for this drawable as a color state list.

    A Drawable's drawing content will be blended together with its tint before it is drawn to the screen.

    Note: Setting a color filter via `setColorFilter(ColorFilter)` overrides tint.

    Parameters:
      `tint` - Color state list to use for tinting this drawable, or `null` to clear the tint
    See Also:
      - `setTint(int)`
      - `setTintBlendMode(BlendMode)`

  - ### setTintBlendMode

    public void setTintBlendMode(@NonNull BlendMode blendMode)
    Specifies a tint blending mode for this drawable.

    Defines how this drawable's tint color should be blended into the drawable before it is drawn to screen. Default tint mode is `BlendMode.SRC_IN`.

    Note: Setting a color filter via `setColorFilter(ColorFilter)`

    Parameters:
      `blendMode` - BlendMode to apply to the drawable, a value of null sets the default blend mode value of `BlendMode.SRC_IN`
    See Also:
      - `setTint(int)`
      - `setTintList(ColorStateList)`

  - ### setColorFilter

    public void setColorFilter(@Nullable ColorFilter colorFilter)
    Specify an optional color filter for the drawable.

    If a Drawable has a ColorFilter, each output pixel of the Drawable's drawing contents will be modified by the color filter before it is blended onto the render target of a Canvas.

    Pass `null` to remove any existing color filter.

    Note: Setting a non-`null` color filter disables `tint`.

    Parameters:
      `colorFilter` - The color filter to apply, or `null` to remove the existing color filter

  - ### getColorFilter

    @Nullable public ColorFilter getColorFilter()
    Returns the current color filter, or `null` if none set.
    Returns:
      the current color filter, or `null` if none set

  - ### setHotspot

    public void setHotspot(float x, float y)
    Specifies the hotspot's location within the drawable.
    Parameters:
      `x` - The X coordinate of the center of the hotspot
      `y` - The Y coordinate of the center of the hotspot

  - ### setHotspotBounds

    public void setHotspotBounds(int left, int top, int right, int bottom)
    Sets the bounds to which the hotspot is constrained, if they should be different from the drawable bounds.
    Parameters:
      `left` - position in pixels of the left bound
      `top` - position in pixels of the top bound
      `right` - position in pixels of the right bound
      `bottom` - position in pixels of the bottom bound
    See Also:
      - `getHotspotBounds(Rect)`

  - ### getHotspotBounds

    public void getHotspotBounds(@NonNull Rect outRect)
    Populates `outRect` with the hotspot bounds.
    Parameters:
      `outRect` - the rect to populate with the hotspot bounds
    See Also:
      - `setHotspotBounds(int, int, int, int)`

  - ### isStateful

    public boolean isStateful()
    Indicates whether this drawable will change its appearance based on state. Clients can use this to determine whether it is necessary to calculate their state and call setState.
    Returns:
      True if this drawable changes its appearance based on state, false otherwise.
    See Also:
      - `setState(int[])`

  - ### hasFocusStateSpecified

    public boolean hasFocusStateSpecified()
    Indicates whether this drawable has at least one state spec explicitly specifying state_focused.

    Note: A View uses a `Drawable` instance as its background and it changes its appearance based on a state. On keyboard devices, it should specify its state_focused to make sure the user knows which view is holding the focus.

    Returns:
      `true` if state_focused is specified for this drawable.

  - ### setState

    public boolean setState(@NonNull int[] stateSet)
    Specify a set of states for the drawable. These are use-case specific, so see the relevant documentation. As an example, the background for widgets like Button understand the following states: [state_focused, state_pressed].

    If the new state you are supplying causes the appearance of the Drawable to change, then it is responsible for calling `invalidateSelf()` in order to have itself redrawn, and true will be returned from this function.

    Note: The Drawable holds a reference on to stateSet until a new state array is given to it, so you must not modify this array during that time.

    Parameters:
      `stateSet` - The new set of states to be displayed.
    Returns:
      Returns true if this change in state has caused the appearance of the Drawable to change (hence requiring an invalidate), otherwise returns false.

  - ### getState

    @NonNull public int[] getState()
    Describes the current state, as a union of primitive states, such as `R.attr.state_focused`, `R.attr.state_selected`, etc. Some drawables may modify their imagery based on the selected state.
    Returns:
      An array of resource Ids describing the current state.

  - ### jumpToCurrentState

    public void jumpToCurrentState()
    If this Drawable does transition animations between states, ask that it immediately jump to the current state and skip any active animations.

  - ### getCurrent

    @Nullable public Drawable getCurrent()
    Returns:
      The current drawable that will be used by this drawable. For simple drawables, this is just the drawable itself. For drawables that change state like `StateListDrawable` and `LevelListDrawable` this will be the child drawable currently in use.

  - ### setLevel

    public final boolean setLevel(@IntRange(from=0L,to=10000L) int level)
    Specify the level for the drawable. This allows a drawable to vary its imagery based on a continuous controller, for example to show progress or volume level.

    If the new level you are supplying causes the appearance of the Drawable to change, then it is responsible for calling `invalidateSelf()` in order to have itself redrawn, and true will be returned from this function.

    Parameters:
      `level` - The new level, from 0 (minimum) to 10000 (maximum).
    Returns:
      Returns true if this change in level has caused the appearance of the Drawable to change (hence requiring an invalidate), otherwise returns false.
    See Also:
      - `MAX_LEVEL`

  - ### getLevel

    @IntRange(from=0L, to=10000L) public final int getLevel()
    Retrieve the current level.
    Returns:
      int Current level, from 0 (minimum) to 10000 (maximum).
    See Also:
      - `MAX_LEVEL`

  - ### setVisible

    public boolean setVisible(boolean visible, boolean restart)
    Set whether this Drawable is visible. This generally does not impact the Drawable's behavior, but is a hint that can be used by some Drawables, for example, to decide whether run animations.
    Parameters:
      `visible` - Set to true if visible, false if not.
      `restart` - You can supply true here to force the drawable to behave as if it has just become visible, even if it had last been set visible. Used for example to force animations to restart.
    Returns:
      true if the new visibility is different from its previous state.

  - ### isVisible

    public final boolean isVisible()

  - ### setAutoMirrored

    public void setAutoMirrored(boolean mirrored)
    Set whether this Drawable is automatically mirrored when its layout direction is RTL (right-to left). See `LayoutDirection`.
    Parameters:
      `mirrored` - Set to true if the Drawable should be mirrored, false if not.

  - ### isAutoMirrored

    public boolean isAutoMirrored()
    Tells if this Drawable will be automatically mirrored when its layout direction is RTL right-to-left. See `LayoutDirection`.
    Returns:
      boolean Returns true if this Drawable will be automatically mirrored.

  - ### applyTheme

    public void applyTheme(@NonNull Theme t)
    Applies the specified theme to this Drawable and its children.
    Parameters:
      `t` - the theme to apply

  - ### canApplyTheme

    public boolean canApplyTheme()

  - ### onStateChange

    protected boolean onStateChange(@NonNull int[] state)
    Override this in your subclass to change appearance if you recognize the specified state.
    Returns:
      Returns true if the state change has caused the appearance of the Drawable to change (that is, it needs to be drawn), else false if it looks the same and there is no need to redraw it since its last state.

  - ### onLevelChange

    protected boolean onLevelChange(int level)
    Override this in your subclass to change appearance if you vary based on level.
    Returns:
      Returns true if the level change has caused the appearance of the Drawable to change (that is, it needs to be drawn), else false if it looks the same and there is no need to redraw it since its last level.

  - ### onBoundsChange

    protected void onBoundsChange(@NonNull Rect bounds)
    Override this in your subclass to change appearance if you vary based on the bounds.

  - ### getIntrinsicWidth

    public int getIntrinsicWidth()
    Returns the drawable's intrinsic width.

    Intrinsic width is the width at which the drawable would like to be laid out, including any inherent padding. If the drawable has no intrinsic width, such as a solid color, this method returns -1.

    Returns:
      the intrinsic width, or -1 if no intrinsic width

  - ### getIntrinsicHeight

    public int getIntrinsicHeight()
    Returns the drawable's intrinsic height.

    Intrinsic height is the height at which the drawable would like to be laid out, including any inherent padding. If the drawable has no intrinsic height, such as a solid color, this method returns -1.

    Returns:
      the intrinsic height, or -1 if no intrinsic height

  - ### getMinimumWidth

    public int getMinimumWidth()
    Returns the minimum width suggested by this Drawable. If a View uses this Drawable as a background, it is suggested that the View use at least this value for its width. (There will be some scenarios where this will not be possible.) This value should INCLUDE any padding.
    Returns:
      The minimum width suggested by this Drawable. If this Drawable doesn't have a suggested minimum width, 0 is returned.

  - ### getMinimumHeight

    public int getMinimumHeight()
    Returns the minimum height suggested by this Drawable. If a View uses this Drawable as a background, it is suggested that the View use at least this value for its height. (There will be some scenarios where this will not be possible.) This value should INCLUDE any padding.
    Returns:
      The minimum height suggested by this Drawable. If this Drawable doesn't have a suggested minimum height, 0 is returned.

  - ### getPadding

    public boolean getPadding(@NonNull Rect padding)
    Return in padding the insets suggested by this Drawable for placing content inside the drawable's bounds. Positive values move toward the center of the Drawable (set `Rect.inset(int, int)`).
    Returns:
      true if this drawable actually has a padding, else false. When false is returned, the padding is always set to 0.

  - ### mutate

    @NonNull public Drawable mutate()
    Make this drawable mutable. This operation cannot be reversed. A mutable drawable is guaranteed to not share its state with any other drawable. This is especially useful when you need to modify properties of drawables loaded from resources. By default, all drawables instances loaded from the same resource share a common state; if you modify the state of one instance, all the other instances will receive the same modification.

    Calling this method on a mutable Drawable will have no effect.

    Returns:
      This drawable.
    See Also:
      - `Drawable.ConstantState`
      - `getConstantState()`

  - ### clearMutated

    @Internal public void clearMutated()
    Clears the mutated state, allowing this drawable to be cached and mutated again.

  - ### getConstantState

    @Nullable public Drawable.ConstantState getConstantState()
    Return a `Drawable.ConstantState` instance that holds the shared state of this Drawable.
    Returns:
      The ConstantState associated to that Drawable.
    See Also:
      - `Drawable.ConstantState`
      - `mutate()`

  - ### scaleFromDensity

    @Internal public static float scaleFromDensity(float pixels, int sourceDensity, int targetDensity)
    Scales a floating-point pixel value from the source density to the target density.
    Parameters:
      `pixels` - the pixel value for use in source density
      `sourceDensity` - the source density
      `targetDensity` - the target density
    Returns:
      the scaled pixel value for use in target density

  - ### scaleFromDensity

    @Internal public static int scaleFromDensity(int pixels, int sourceDensity, int targetDensity, boolean isSize)
    Scales a pixel value from the source density to the target density, optionally handling the resulting pixel value as a size rather than an offset.

    A size conversion involves rounding the base value and ensuring that a non-zero base value is at least one pixel in size.

    An offset conversion involves simply truncating the base value to an integer.

    Parameters:
      `pixels` - the pixel value for use in source density
      `sourceDensity` - the source density
      `targetDensity` - the target density
      `isSize` - `true` to handle the resulting scaled value as a size, or `false` to handle it as an offset
    Returns:
      the scaled pixel value for use in target density